/* Programare Orientata pe Obiecte (POO)
   Object Oriented Programming (OOP)

   Principiile (mecanismele) POO:
   1. Abstractizare
   2. Incapsulare si Protectia Datelor
   3. Mostenire
   4. Polimorfism
*/
#include <iostream>
#include <string>

/* In mod implicit toti membrii unei clase sunt privati
   In mod implicit toti membrii unei structuri sunt publici
*/
class Student {
public:
    // Functii Membre (Metode - Java)
    void Print()
    {
        std::cout << name << ' ' << age << '\n';
    }
    // Se creaza functii accesoare:

    void SetName(std::string _name)
    {
        name = _name;
    }

    std::string GetName()
    {
        return name;
    }

    void SetAge(int _age)
    {
        if (_age <= 0)
            age = 0;
        else
            if (_age > 150)
                age = 150;
            else
                age = _age;
    }

    int GetAge()
    {
        return age;
    }

private:
    // Datele Membre (Campuri - Java)ale structurii
    std::string name;
    int age;
};

int main()
{
    int x;
    Student s; // s = OBIECT sau INSTANTA a clasei

    // SINTAXA: OBIECT.MEMBRU_PUBLIC
 //   s.name = "Ionel";
 //   s.age = -16;

    s.SetName("Mariana");
    s.SetAge(16);

//    s.Print();
    std::cout << s.GetName() << ' '
              << s.GetAge();
    return 0;
}
