/* Constructori si Destructor
    Constructorii sunt Functii Membre Speciale care:
        1. Se apeleaza de cate ori este nevoie de construirea unui obiect
        2. Au numele clasei
        3. Pot sa aiba sau nu, parametri
        4. Nu au tip de retur (nici macar void)
        5. Daca programatorul nu scrie niciun c-tor in clasa, atunci
           compilatorul genereaza un c-tor DEFAULT (implicit)


    Constructorul este Functie Membra Speciala care:
        1. Se apeleaza de cate ori este nevoie de distrugerea unui obiect
        2. Are numele clasei
        3. NU ARE parametri
        4. Nu are tip de retur (nici macar void)
        5. Daca programatorul nu scrie niciun d-tor in clasa, atunci
           compilatorul genereaza un d-tor DEFAULT (implicit)

*/
#include <iostream>
#include <string>

class House {
public:
    House()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    ~House()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
};

int main()
{
    std::cout << "Prima instructiune\n";

    {
        House h;
    }

    std::cout << "Ultima instructiune\n";
}
